#line 1 "F:/MikroC/ModbusMaster/main.c"
#line 1 "f:/mikroc/modbusmaster/modbusmaster.h"
#line 1 "f:/mikroc/modbusmaster/modbus.h"
#line 1 "f:/mikroc/modbusmaster/types.h"
#line 14 "f:/mikroc/modbusmaster/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 57 "f:/mikroc/modbusmaster/modbus.h"
 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusTypes {
 INVALID_MB_TYPE = 0,
 COILS = 1,
 STATUS_INPUTS = 2,
 HOLDING_REGISTERS = 3,
 INPUT_REGISTERS = 4
 } mbType;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _modbusBlock {

 byte bytSlaveAddress;

 mbType eType;

 uint uintAddress;

 uint uintTotal;

 void* paryData;

 void (*pCallback)();

 struct _modbusBlock* pNext;
 } modbusBlockDef;

 boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,
 void (*pCallback)());
 uint calcCRC(void);
 void decodePacket(void);
 int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...);
 void restartRx(void);
 void startTimeout(void);


 extern modbusBlockDef* pCurrBlock;

 extern modbusBlockDef* pHoldingRegs;
 extern modbusBlockDef* pStatusBits;
 extern modbusBlockDef* pInputRegs;
 extern modbusBlockDef* pCoils;

 extern mbException eMbExceptionCode;

 extern uint uintMbRxGapSetPt1;
 extern uint uintMbRxGapSetPt2;
 extern uint uintMbRxGapSetPt3;
 extern uint uintMbRxGapSetPt;

 extern uint uintPacketTimeout;

 extern uint uintCRC;

 extern uint uintMbRxGap;

 extern byte bytMbSlaveAddress;

 extern byte arybytMbBuffer[ 256 ];

 extern byte bytMbRxphase;
 extern byte bytMbIndex;

 extern sfr sbit Tx_dir;
#line 25 "f:/mikroc/modbusmaster/modbusmaster.h"
 typedef enum eModbusBlockStatus {
 BLOCK_STATUS_UNKNOWN = 0,
 BLOCK_STATUS_READY = 1,
 BLOCK_STATUS_SUSPEND = 2,
 BLOCK_STATUS_WRITE = 3,
 BLOCK_STATUS_WAITING_FOR_RESPONSE = 4,
 BLOCK_STATUS_RETRY = 5
 } mbBlockStatus;

 typedef struct _modbusPollSchedule {

 modbusBlockDef* pBlock;

 mbBlockStatus eStatus;

 byte bytLastFC;

 uint uintPL;

 uint uintERL;

 void (*pModify)(struct _modbusPollSchedule* pSchedule);

 uint uintItemsToModify;

 uint uintStartAddress;

 byte arybytPendingWrite[ 123  * 2];

 struct _modbusPollSchedule* pNext;
 } modbusPollScheduleDef;

 void decodePacket(void);
 boolean modifyBlock(modbusPollScheduleDef* pSchedule,
 uint uintAddress, uint uintTotal, byte* pData);
 boolean scheduleRequest(modbusBlockDef* pBlock,
 modbusPollScheduleDef* pSchedule);
 void serviceSchedule(void);
 void unpackBits(byte* pBuffer);
 void unpackWords(byte* pBuffer);
#line 14 "F:/MikroC/ModbusMaster/main.c"
static volatile modbusBlockDef coilsBlock,
 statusBitsBlock,
 inputRegsBlock,
 holdingRegsBlock;
static volatile uint aryuintInputRegs[1], aryuintHoldingRegs[2];
static volatile byte arybytCoils[1], arybytStatusBits[1];
static volatile modbusPollScheduleDef coilsSchedule,
 statusSchedule,
 inputRegSchedule,
 holdingRegSchedule;
#line 27 "F:/MikroC/ModbusMaster/main.c"
void interrupt() {
 decodePacket();
}
#line 33 "F:/MikroC/ModbusMaster/main.c"
void coilsCallBack(void) {
 LATB = ((byte*)pCurrBlock->paryData)[0];
}
#line 39 "F:/MikroC/ModbusMaster/main.c"
void statusCallBack(void) {

}
#line 45 "F:/MikroC/ModbusMaster/main.c"
void holdingRegCallBack(void) {
 LATB = ((uint*)pCurrBlock->paryData)[0];
}
#line 51 "F:/MikroC/ModbusMaster/main.c"
void main() {
 byte bytData[16];

 ANSELB = 0;
 ANSELD = 0;

 TRISB = 0;

 TRISD = 0xff;

 LATB = 0;

 modbusSerialInit(BAUD_115200, 1);

 memset(arybytCoils, 0, sizeof(arybytCoils));
 memset(arybytStatusBits, 0, sizeof(arybytStatusBits));
 memset(aryuintHoldingRegs, 0, sizeof(aryuintHoldingRegs));
 memset(aryuintInputRegs, 0, sizeof(aryuintInputRegs));

 addModbusBlock(1, COILS, &coilsBlock, 1, 8,
 (void*)arybytCoils, coilsCallBack);
 addModbusBlock(1, STATUS_INPUTS, &statusBitsBlock, 1, 8,
 (void*)arybytStatusBits, statusCallBack);
 addModbusBlock(1, HOLDING_REGISTERS, &holdingRegsBlock, 1, 2,
 (void*)aryuintHoldingRegs, holdingRegCallBack);
 addModbusBlock(1, INPUT_REGISTERS, &inputRegsBlock, 1, 1,
 (void*)aryuintInputRegs,  ((void*)0) );

 scheduleRequest(&coilsBlock, &coilsSchedule);
 scheduleRequest(&statusBitsBlock, &statusSchedule);
 scheduleRequest(&holdingRegsBlock, &holdingRegSchedule);
 scheduleRequest(&inputRegsBlock, &inputRegSchedule);

 while (1) {
 serviceSchedule();

 if ( Button(&PORTD, 0, 1, 1) ) {
 bytData[0] = 0x01;
 modifyBlock(&coilsSchedule, 1, 1, bytData);
 }
 if ( Button(&PORTD, 1, 1, 1) ) {
 bytData[0] = 0x3d;
 modifyBlock(&coilsSchedule, 1, 7, bytData);
 }
 if ( Button(&PORTD, 2, 1, 1) ) {
 bytData[0] = 0xca;
 bytData[1] = 0xca;
 modifyBlock(&holdingRegSchedule, 1, 1, bytData);
 }
 if ( Button(&PORTD, 3, 1, 1) ) {
 bytData[0] = 0x04;
 bytData[1] = 0xd2;
 bytData[2] = 0x16;
 bytData[3] = 0x2e;
 modifyBlock(&holdingRegSchedule, 1, 2, bytData);
 }
 }
}
