#line 1 "F:/MikroC/ModbusMaster/modbusMaster.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdarg.h"





typedef void * va_list[1];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/modbusmaster/modbusmaster.h"
#line 1 "f:/mikroc/modbusmaster/modbus.h"
#line 1 "f:/mikroc/modbusmaster/types.h"
#line 14 "f:/mikroc/modbusmaster/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 57 "f:/mikroc/modbusmaster/modbus.h"
 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusTypes {
 INVALID_MB_TYPE = 0,
 COILS = 1,
 STATUS_INPUTS = 2,
 HOLDING_REGISTERS = 3,
 INPUT_REGISTERS = 4
 } mbType;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _modbusBlock {

 byte bytSlaveAddress;

 mbType eType;

 uint uintAddress;

 uint uintTotal;

 void* paryData;

 void (*pCallback)();

 struct _modbusBlock* pNext;
 } modbusBlockDef;

 boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,
 void (*pCallback)());
 uint calcCRC(void);
 void decodePacket(void);
 int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...);
 void restartRx(void);
 void startTimeout(void);


 extern modbusBlockDef* pCurrBlock;

 extern modbusBlockDef* pHoldingRegs;
 extern modbusBlockDef* pStatusBits;
 extern modbusBlockDef* pInputRegs;
 extern modbusBlockDef* pCoils;

 extern mbException eMbExceptionCode;

 extern uint uintMbRxGapSetPt1;
 extern uint uintMbRxGapSetPt2;
 extern uint uintMbRxGapSetPt3;
 extern uint uintMbRxGapSetPt;

 extern uint uintPacketTimeout;

 extern uint uintCRC;

 extern uint uintMbRxGap;

 extern byte bytMbSlaveAddress;

 extern byte arybytMbBuffer[ 256 ];

 extern byte bytMbRxphase;
 extern byte bytMbIndex;

 extern sfr sbit Tx_dir;
#line 25 "f:/mikroc/modbusmaster/modbusmaster.h"
 typedef enum eModbusBlockStatus {
 BLOCK_STATUS_UNKNOWN = 0,
 BLOCK_STATUS_READY = 1,
 BLOCK_STATUS_SUSPEND = 2,
 BLOCK_STATUS_WRITE = 3,
 BLOCK_STATUS_WAITING_FOR_RESPONSE = 4,
 BLOCK_STATUS_RETRY = 5
 } mbBlockStatus;

 typedef struct _modbusPollSchedule {

 modbusBlockDef* pBlock;

 mbBlockStatus eStatus;

 byte bytLastFC;

 uint uintPL;

 uint uintERL;

 void (*pModify)(struct _modbusPollSchedule* pSchedule);

 uint uintItemsToModify;

 uint uintStartAddress;

 byte arybytPendingWrite[ 123  * 2];

 struct _modbusPollSchedule* pNext;
 } modbusPollScheduleDef;

 void decodePacket(void);
 boolean modifyBlock(modbusPollScheduleDef* pSchedule,
 uint uintAddress, uint uintTotal, byte* pData);
 boolean scheduleRequest(modbusBlockDef* pBlock,
 modbusPollScheduleDef* pSchedule);
 void serviceSchedule(void);
 void unpackBits(byte* pBuffer);
 void unpackWords(byte* pBuffer);
#line 32 "F:/MikroC/ModbusMaster/modbusMaster.c"
static volatile modbusPollScheduleDef* pPollSchedule =  ((void*)0) ;
static volatile modbusPollScheduleDef* pCurrPoll =  ((void*)0) ;
static volatile modbusPollScheduleDef* pLast;
static volatile boolean blnBusy = FALSE;
static volatile byte bytRetries = 0;
static volatile uint uintPacketCtr;

static volatile mbBlockStatus eCurrent, eLastStatus;
#line 50 "F:/MikroC/ModbusMaster/modbusMaster.c"
static int nextSchedule(void) {
 if ( pCurrPoll !=  ((void*)0)  ) {
 eLastStatus = pCurrPoll->eStatus;

 pCurrPoll->eStatus = BLOCK_STATUS_READY;
 }

 bytRetries = 0;


 pLast = pCurrPoll;
 while( TRUE ) {
 if ( pCurrPoll ==  ((void*)0)  || pCurrPoll->pNext ==  ((void*)0)  ) {
 pCurrPoll = pPollSchedule;

 if ( pLast ==  ((void*)0)  ) {
 pLast = pCurrPoll;
 }
 } else {
 pCurrPoll = pCurrPoll->pNext;

 if ( pCurrPoll == pLast ) {

 pCurrPoll =  ((void*)0) ;
 return -1;
 }
 }
 eCurrent = pCurrPoll->eStatus;

 if ( pCurrPoll->eStatus == BLOCK_STATUS_READY ) {

 return 0;
 }
 }
}
#line 95 "F:/MikroC/ModbusMaster/modbusMaster.c"
static void modifySingleCoil(modbusPollScheduleDef* pSchedule) {
 if ( pCurrPoll->arybytPendingWrite[0] > 0 ) {
 arybytMbBuffer[bytMbIndex++] = 0xff;
 arybytMbBuffer[bytMbIndex++] = 0x00;
 } else {
 arybytMbBuffer[bytMbIndex++] = 0x00;
 arybytMbBuffer[bytMbIndex++] = 0x00;
 }
}
#line 114 "F:/MikroC/ModbusMaster/modbusMaster.c"
static void modifySingleHoldingRegister(modbusPollScheduleDef* pSchedule) {
 arybytMbBuffer[bytMbIndex++] = pCurrPoll->arybytPendingWrite[1];
 arybytMbBuffer[bytMbIndex++] = pCurrPoll->arybytPendingWrite[0];
}
#line 128 "F:/MikroC/ModbusMaster/modbusMaster.c"
static void modifyMultiple(modbusPollScheduleDef* pSchedule) {
 byte bytCount, bytIndex;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->uintItemsToModify)[1] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->uintItemsToModify)[0] ;
 if ( pCurrPoll->pBlock->eType == HOLDING_REGISTERS ) {
 bytCount = pCurrPoll->uintItemsToModify * 2;
 } else {
 bytCount = (pCurrPoll->uintItemsToModify / 8) +
 (pCurrPoll->uintItemsToModify % 8) ? 1 : 0;
 }
 arybytMbBuffer[bytMbIndex++] = bytCount;
 for( bytIndex=0; bytIndex<bytCount; bytIndex++ ) {
 arybytMbBuffer[bytMbIndex++] = pCurrPoll->arybytPendingWrite[bytIndex];
 }
}
#pragma funcall decodePacket dummy
#line 155 "F:/MikroC/ModbusMaster/modbusMaster.c"
void decodePacket(void) {
 if ( TMR2IF_bit ) {
 if ( uintPacketCtr < uintPacketTimeout ) {
 uintPacketCtr++;
 } else {

 if ( pCurrPoll
 && pCurrPoll->eStatus == BLOCK_STATUS_WAITING_FOR_RESPONSE ) {

 if ( ++bytRetries >=  3  ) {

 nextSchedule();
 } else {
 pCurrPoll->eStatus = BLOCK_STATUS_RETRY;
 }

 TMR2ON_bit = 0;
 TMR2IE_bit = 0;
 blnBusy = FALSE;
 }
 }
 TMR2IF_bit = 0;
 return;
 }
 if ( TMR0IF_bit ) {
 bytMbRxphase.B0 = 1;
 TMR0ON_bit = 0;

 TMR0IF_bit = 0;

 if ( bytMbRxphase.B7 ) {

 restartRx();

 uintPacketCtr = 0;
 TMR2ON_bit = 1;
 TMR2IE_bit = 1;
 return;
 }
 }
 if( RCIF_bit ) {
 byte bytTemp;

 if ( OERR_bit || FERR_bit ) {
 bytTemp = RCREG;
 bytTemp = RCREG;

 CREN_bit = 0;
 CREN_bit = 1;
 bytMbRxphase.B0 = 0;
 bytMbRxphase.B4 = 1;
 startTimeout();
 return;
 }


 bytTemp = RCREG;


 if ( bytMbRxphase == 0
 || bytMbRxphase.B2 == 1
 || bytMbRxphase.B4 == 1
 || bytMbIndex >=  256  ) {

 bytMbRxphase.B0 = 0;
 bytMbRxphase.B4 = 1;
 startTimeout();
 return;
 }
 if ( bytMbIndex == 0) {

 bytMbRxphase = 2;
 }
 if ( bytMbRxphase <= 2 ) {

 arybytMbBuffer[bytMbIndex++] = bytTemp;
 }

 startTimeout();
 } else if ( bytMbRxphase.B7 ) {
 if ( TXIF_bit && TXIE_bit ) {
 if ( pCurrPoll && bytMbIndex < pCurrPoll->uintPL ) {
 TXREG = arybytMbBuffer[bytMbIndex++];
 } else {

 startTimeout();

 TXIE_bit = 0;
 }
 return;
 }
 }
 if ( bytMbRxphase == 3 ) {

 bytMbRxphase = 4;
 startTimeout();
 }
 if ( bytMbRxphase != 5 ) {

 return;
 }

 if ( bytMbIndex > 3 ) {
 if ( pCurrPoll
 && arybytMbBuffer[0] == pCurrPoll->pBlock->bytSlaveAddress
 && (arybytMbBuffer[1] & 0x7f) == pCurrPoll->bytLastFC ) {

 bytMbIndex -= 2;
 uintCRC = calcCRC();

 if (  ((char *)&uintCRC)[0]  == arybytMbBuffer[bytMbIndex] &&
  ((char *)&uintCRC)[1]  == arybytMbBuffer[bytMbIndex + 1] ) {

 if ( (arybytMbBuffer[1] &  0x80 ) !=  0x80 
 && bytMbIndex >= (pCurrPoll->uintERL - 2) ) {
 switch( pCurrPoll->bytLastFC ) {
 case READ_COILS:
 case READ_STATUS_INPUTS:
 unpackBits(&arybytMbBuffer[2]);
 break;
 case READ_HOLDING_REGISTERS:
 case READ_INPUT_REGISTERS:

 break;
 }
 }

 nextSchedule();

 bytMbRxphase.B6 = 1;
 blnBusy = FALSE;
 }
 }
 }

 bytMbRxphase.B5 = 1;

 if ( !bytMbRxphase.B6 ) {

 uintPacketCtr = uintPacketTimeout;
 TMR2IF_bit = 1;
 }
}
#line 311 "F:/MikroC/ModbusMaster/modbusMaster.c"
boolean modifyBlock(modbusPollScheduleDef* pSchedule,
 uint uintAddress, uint uintTotal, byte* pData) {

 if ( pSchedule ==  ((void*)0) 
 || pSchedule->pBlock ==  ((void*)0) 
 || uintAddress == 0
 || uintTotal == 0
 || pData ==  ((void*)0) 
 || uintAddress < pSchedule->pBlock->uintAddress
 || (uintAddress + uintTotal - 1) >
 (pSchedule->pBlock->uintAddress + pSchedule->pBlock->uintTotal - 1)
 || !(pSchedule->pBlock->eType == COILS
 || pSchedule->pBlock->eType == HOLDING_REGISTERS) ) {
 return FALSE;
 }

 pSchedule->uintStartAddress = uintAddress - 1;
 pSchedule->uintItemsToModify = uintTotal;

 if ( pSchedule->pBlock->eType == COILS ) {
 memcpy(pSchedule->arybytPendingWrite, pData,
 (uintTotal / 8) + ((uintTotal % 8) ? 1 : 0));
 } else {
 memcpy(pSchedule->arybytPendingWrite, pData, (uintTotal * 2));
 }
 if ( pSchedule->pBlock->eType == COILS ) {
 if ( pSchedule->uintItemsToModify == 1 ) {
 pSchedule->pModify = modifySingleCoil;
 } else {
 pSchedule->pModify = modifyMultiple;
 }
 } else {
 if ( pSchedule->uintItemsToModify == 1 ) {
 pSchedule->pModify = modifySingleHoldingRegister;
 } else {
 pSchedule->pModify = modifyMultiple;
 }
 }
 return TRUE;
}
#line 362 "F:/MikroC/ModbusMaster/modbusMaster.c"
boolean scheduleRequest(modbusBlockDef* pBlock,
 modbusPollScheduleDef* pSchedule) {

 if ( pBlock ==  ((void*)0) 
 || pBlock->eType == INVALID_MB_TYPE
 || pBlock->uintAddress == 0
 || pBlock->uintTotal == 0
 || pBlock->paryData ==  ((void*)0)  ) {
 return FALSE;
 }
 if ( pPollSchedule ==  ((void*)0)  ) {

 pPollSchedule = pSchedule;




 T2CON = 0b01001010;
 PR2 = 249;
 } else {

 modbusPollScheduleDef* pNode;
 for( pNode=pPollSchedule; pNode->pNext!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->pBlock == pBlock ) {

 return FALSE;
 }
 }

 pNode->pNext = pSchedule;
 }
 pSchedule->pBlock = pBlock;
 pSchedule->pNext =  ((void*)0) ;
 pSchedule->pModify =  ((void*)0) ;
 pSchedule->uintItemsToModify = 0;
 pSchedule->eStatus = BLOCK_STATUS_READY;
 return TRUE;
}
#line 410 "F:/MikroC/ModbusMaster/modbusMaster.c"
void serviceSchedule(void) {
 uint uintAddress;
#line 415 "F:/MikroC/ModbusMaster/modbusMaster.c"
 if ( blnBusy == TRUE ) {

 return;
 }
 if ( pCurrPoll ==  ((void*)0)  ) {

 pCurrPoll = pPollSchedule;
 }
 if ( !(pCurrPoll->eStatus == BLOCK_STATUS_READY
 || pCurrPoll->eStatus == BLOCK_STATUS_RETRY) ) {
 return;
 }

 pCurrPoll->eStatus = BLOCK_STATUS_WAITING_FOR_RESPONSE;

 if ( pCurrPoll->pBlock->eType == COILS ) {
 if ( pCurrPoll->pModify ==  ((void*)0)  ) {
 pCurrPoll->bytLastFC = READ_COILS;
 } else if ( pCurrPoll->uintItemsToModify == 1 ) {
 pCurrPoll->bytLastFC = FORCE_SINGLE_COIL;
 } else {
 pCurrPoll->bytLastFC = FORCE_MULTIPLE_COILS;
 }
 } else if ( pCurrPoll->pBlock->eType == STATUS_INPUTS ) {
 pCurrPoll->bytLastFC = READ_STATUS_INPUTS;
 } else if ( pCurrPoll->pBlock->eType == HOLDING_REGISTERS ) {
 if ( pCurrPoll->pModify ==  ((void*)0)  ) {
 pCurrPoll->bytLastFC = READ_HOLDING_REGISTERS;
 } else if ( pCurrPoll->uintItemsToModify == 1 ) {
 pCurrPoll->bytLastFC = PRESET_SINGLE_REGISTER;
 } else {
 pCurrPoll->bytLastFC = PRESET_MULTIPLE_REGISTERS;
 }
 } else if ( pCurrPoll->pBlock->eType == INPUT_REGISTERS ) {
 pCurrPoll->bytLastFC = READ_INPUT_REGISTERS;
 } else {

 return;
 }

 if ( pCurrPoll->pBlock->eType == COILS
 || pCurrPoll->pBlock->eType == STATUS_INPUTS ) {

 pCurrPoll->uintERL = 5 +
 ((pCurrPoll->pBlock->uintTotal / 8) +
 (((pCurrPoll->pBlock->uintTotal % 8) > 0) ? 1 : 0));
 } else if ( pCurrPoll->pBlock->eType == HOLDING_REGISTERS
 || pCurrPoll->pBlock->eType == INPUT_REGISTERS ) {

 pCurrPoll->uintERL = 5 + (pCurrPoll->pBlock->uintTotal * 2);
 }
 bytMbIndex = 0;

 arybytMbBuffer[bytMbIndex++] = pCurrPoll->pBlock->bytSlaveAddress;

 arybytMbBuffer[bytMbIndex++] = pCurrPoll->bytLastFC;

 if ( pCurrPoll->pModify !=  ((void*)0)  ) {

 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->uintStartAddress)[1] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->uintStartAddress)[0] ;

 (*pCurrPoll->pModify)(pCurrPoll);

 pCurrPoll->pModify =  ((void*)0) ;
 } else {

 uintAddress = pCurrPoll->pBlock->uintAddress - 1;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintAddress)[1] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintAddress)[0] ;

 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->pBlock->uintTotal)[1] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&pCurrPoll->pBlock->uintTotal)[0] ;
 }

 uintCRC = calcCRC();
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintCRC)[0] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintCRC)[1] ;

 pCurrPoll->uintPL = bytMbIndex;

 while( bytMbRxphase.B0 == 0 ) ;

 CREN_bit = 0;
 RCIE_bit = 0;

 TXEN_bit = 1;
 Tx_dir = 1;

 bytMbRxphase = 128;

 TXREG = arybytMbBuffer[0];

 while( !TXIF_bit ){}
 TXREG = arybytMbBuffer[1];

 blnBusy = TRUE;

 bytMbIndex = 2;
 TXIE_bit = 1;
}
#line 526 "F:/MikroC/ModbusMaster/modbusMaster.c"
void unpackBits(byte* pBuffer) {
 byte* pbytData, bytBit, bitMask;
 byte bytByteCount;

 bytByteCount = *pBuffer;
 pBuffer++;
 pCurrBlock = pCurrPoll->pBlock;
 pbytData = (byte*)pCurrBlock->paryData;
 while( bytByteCount-- ) {
 for( bytBit=0; bytBit<8; bytBit++ ) {
 bitMask = 1 << bytBit;

 if ( (*pBuffer & bitMask) == bitMask ) {
 *pbytData |= bitMask;
 } else {
 *pbytData &= (0xff ^ bitMask);
 }
 }
 pbytData++;
 pBuffer++;
 }

 if ( pCurrBlock->pCallback !=  ((void*)0)  ) {
 (*pCurrBlock->pCallback)();
 }
}
#line 562 "F:/MikroC/ModbusMaster/modbusMaster.c"
void unpackWords(byte* pBuffer) {
 byte bytByteCount;
 uint* puintData;

 bytByteCount = *pBuffer;
 pBuffer++;
 pCurrBlock = pCurrPoll->pBlock;
 puintData = (uint*)pCurrBlock->paryData;
 while( bytByteCount-- ) {
  ((char *)&puintData)[1]  = *pBuffer;
 pBuffer++;
  ((char *)&puintData)[0]  = *pBuffer;
 pBuffer++;
 puintData++;
 }

 if ( pCurrBlock->pCallback !=  ((void*)0)  ) {
 (*pCurrBlock->pCallback)();
 }
}
